//
//  main.swift
//  PhantomTypes
//
//  Created by Paul Hudson on 17/06/2020.
//  Copyright © 2020 Paul Hudson. All rights reserved.
//

import Foundation

struct Employee<Role>: Equatable {
    var name: String
}

enum Sales { }
enum Programmer { }

let zoe1 = Employee<Programmer>(name: "Zoe")
let zoe2 = Employee<Sales>(name: "Zoe")

// this should fail to compile
print(zoe1 == zoe2)



enum OPositive { }
enum APositive { }
enum BPositive { }

struct BloodSample<Type> {
    let amount: Double

    static func +(lhs: BloodSample, rhs: BloodSample) -> BloodSample {
        BloodSample(amount: lhs.amount + rhs.amount)
    }
}

let sample1 = BloodSample<OPositive>(amount: 5)
let sample2 = BloodSample<APositive>(amount: 5)
let sample3 = BloodSample<OPositive>(amount: 7)

let combined1 = sample1 + sample3

// this should fail to compile
let combined2 = sample1 + sample2




enum UserID { }
enum Age { }

struct Tag<Type>: Equatable, ExpressibleByIntegerLiteral {
    init(integerLiteral value: Int) {
        self.value = value
    }

    var value: Int
}

struct User {
    let id: Tag<UserID>
    let age: Tag<Age>
}

let user = User(id: 53, age: 53)

// this should fail to compile
print(user.id == user.age)




enum Waiting {}
enum CoinInserted {}
enum Fetching {}
enum Serving {}

struct Transition<From, To> {}

struct Machine<State> {
    func transition<To>(with transition: Transition<State, To>) -> Machine<To> {
        .init()
    }
}

let start = Transition<Waiting, CoinInserted>()
let selectionMade = Transition<CoinInserted, Fetching>()
let delivery = Transition<Fetching, Serving>()
let reset = Transition<Serving, Waiting>()

let m1 = Machine<Waiting>()
let m2 = m1.transition(with: start)
let m3 = m2.transition(with: selectionMade)
let m4 = m3.transition(with: delivery)
let m5 = m4.transition(with: reset)

// this should fail to compile
let m6 = m5.transition(with: delivery)




func undefined<T>(_ message: String = "") -> T {
    fatalError("Undefined: \(message)")
}

let name: String = undefined("Example string")
let score: Int = undefined("Example int")

func userID(for username: String) -> Int? {
    fatalError("This isn't working yet")
}

let timer = Timer(timeInterval: 0, target: undefined(), selector: undefined(), userInfo: undefined(), repeats: true)
